## wbxml2 0.11.10+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
PROJECT( libwbxml C )

SET( LIBWBXML_VERSION_MAJOR "0" )
SET( LIBWBXML_VERSION_MINOR "11" )
SET( LIBWBXML_VERSION_PATCH "10" )
IF( LIBWBXML_VERSION_BETA )
    IF( LIBWBXML_VERSION_BETA VERSION_GREATER 90 )
        MATH( EXPR LIBWBXML_VERSION_MINOR "${LIBWBXML_VERSION_MINOR} - 1" )
        SET( LIBWBXML_VERSION_PATCH ${LIBWBXML_VERSION_BETA})
    ELSE( LIBWBXML_VERSION_BETA VERSION_GREATER 90 )
        SET( LIBWBXML_VERSION_PATCH "beta${LIBWBXML_VERSION_BETA}" )
    ENDIF( LIBWBXML_VERSION_BETA VERSION_GREATER 90 )
ENDIF( LIBWBXML_VERSION_BETA )
SET( LIBWBXML_VERSION "${LIBWBXML_VERSION_MAJOR}.${LIBWBXML_VERSION_MINOR}.${LIBWBXML_VERSION_PATCH}" )

# The most recent interface number that this library implements.
#UPDATE: If any interface have been added, removed or changed since
#UPDATE: the last update increment CURRENT.
SET( LIBWBXML_LIBVERSION_CURRENT 2 )

# The implementation number of the CURRENT interface.
# UPDATE: Increment only if the library code has changed at all, since
# UPDATE: last release.
# UPDATE: Set REVISION to 0 if any interface have been added, removed or
# UPDATE: changed since the last update.
SET( LIBWBXML_LIBVERSION_REVISION 1 )

# The difference between the newest and the oldest interfaces.
# UPDATE: If any interface have been added since the last public
# UPDATE: release, then increment.
# UPDATE: If any interface have been removed since the last release
# UPDATE: reset to 0.
SET( LIBWBXML_LIBVERSION_AGE 1 )

# The range of implemention CURRENT - AGE is the SOVERSION
MATH( EXPR LIBWBXML_LIBVERSION_SOVERSION "${LIBWBXML_LIBVERSION_CURRENT} - ${LIBWBXML_LIBVERSION_AGE}" )

SET( LIBWBXML_LIBVERSION_VERSION "${LIBWBXML_LIBVERSION_SOVERSION}.${LIBWBXML_LIBVERSION_AGE}.${LIBWBXML_LIBVERSION_REVISION}" )

# this hack protects the SO versioning of the library
# it makes the exposing of internal header files possible and safe
# usual library version: 2.6.1
# special library version: 20601.0.0
IF( WBXML_INSTALL_FULL_HEADERS )

    # calculate big major version
    MATH( EXPR LIBWBXML_LIBVERSION_SOVERSION "10000 * ${LIBWBXML_LIBVERSION_SOVERSION} + 100 * ${LIBWBXML_LIBVERSION_AGE} + ${LIBWBXML_LIBVERSION_REVISION}" )

    # build a x.0.0 version
    SET( LIBWBXML_LIBVERSION_VERSION "${LIBWBXML_LIBVERSION_SOVERSION}.0.0" )

ENDIF( WBXML_INSTALL_FULL_HEADERS )

# TODO: Move to external file/macro
SET( CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules" )

SET( LIB_SUFFIX "" CACHE STRING "The library directory suffix. 32bit empty string, 64 for 64bit." )
SET( LIB_INSTALL_DIR  "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}" CACHE INTERNAL "libary location" )
SET( LIBDATA_INSTALL_DIR  "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}" CACHE PATH "The library data directory" )
SET( BIN_INSTALL_DIR  "${CMAKE_INSTALL_PREFIX}/bin" CACHE INTERNAL "binary location" )
SET( SHARE_INSTALL_DIR  "${CMAKE_INSTALL_PREFIX}/share" CACHE INTERNAL "data location" )
SET( INCLUDE_INSTALL_DIR  "${CMAKE_INSTALL_PREFIX}/include" CACHE INTERNAL "headers location" )
SET( LIBEXEC_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/libexec" CACHE INTERNAL "libexec location" )

#MESSAGE(STATUS "CMAKE_MODULE_PATH: ${CMAKE_MODULE_PATH}" )

SET( LIBWBXML_LIBRARIES_DIR "${LIB_INSTALL_DIR}" CACHE PATH "wbxml library location" )
SET( LIBWBXML_INCLUDE_DIR "${INCLUDE_INSTALL_DIR}/libwbxml-${LIBWBXML_LIBVERSION_SOVERSION}.${LIBWBXML_LIBVERSION_AGE}" CACHE PATH "libwbxml headers location" )
SET( LIBWBXML_BIN_DIR "${BIN_INSTALL_DIR}" CACHE PATH "wbxml binaries location" )
SET( LIBWBXML_DATA_DIR "${CMAKE_INSTALL_PREFIX}/share" CACHE PATH "wbxml data location" )
SET( LIBWBXML_EXEC_INSTALL_DIR "${BIN_INSTALL_DIR}" CACHE PATH "wbxml binary location" )

# find header files and type size
INCLUDE( CheckTypeSize )
INCLUDE( CheckIncludeFiles )
INCLUDE( Documentation )
INCLUDE( AddDocumentation )

CHECK_INCLUDE_FILES( limits.h HAVE_LIMITS_H )
CHECK_INCLUDE_FILES( ctype.h HAVE_CTYPE_H )
CHECK_INCLUDE_FILES( stdlib.h HAVE_STDLIB_H )
CHECK_INCLUDE_FILES( stdio.h HAVE_STDIO_H )
CHECK_INCLUDE_FILES( stdarg.h HAVE_STDARG_H )
CHECK_INCLUDE_FILES( assert.h HAVE_ASSERT_H )

# ensure out od source build
INCLUDE( MacroEnsureOutOfSourceBuild )
MACRO_ENSURE_OUT_OF_SOURCE_BUILD("${CMAKE_PROJECT_NAME} doesn't allow to build within the source directory. Please, create a seperate build directory and run 'cmake ${PROJECT_SOURCE_DIR} [options]'!")

# FIXME: popt is embedded into the source code
# popt is not used
# zlib is not used
# nsl is part of libc6

# Expat support
FIND_PACKAGE( Expat REQUIRED )
IF( NOT EXPAT_FOUND )
    # cmake introduced a bug in version 3.27
    FIND_PACKAGE( PkgConfig )
    IF(PKGCONFIG_FOUND)
        PKG_CHECK_MODULES( EXPAT expat )
    ENDIF(PKGCONFIG_FOUND)
ENDIF ( NOT EXPAT_FOUND )
IF( EXPAT_FOUND )
    SET( HAVE_EXPAT 1 )
ENDIF( EXPAT_FOUND )

# Testing support
FIND_PACKAGE( PkgConfig )
IF(PKGCONFIG_FOUND)
    PKG_CHECK_MODULES( CHECK check )
ENDIF(PKGCONFIG_FOUND)
IF(CHECK_FOUND)
	OPTION( ENABLE_UNIT_TEST "enable unit tests" ON )
	ENABLE_TESTING()
ENDIF(CHECK_FOUND)

# Character conversion support
FIND_PACKAGE( Iconv )
SET( WBXML_SUPPORT_ICONV OFF )
IF( ICONV_FOUND )
    SET( HAVE_ICONV 1 )
    SET( WBXML_SUPPORT_ICONV ON )
ENDIF( ICONV_FOUND )

# look for getopt implementation in unistd.h

INCLUDE(CheckFunctionExists)
INCLUDE(CheckIncludeFile)

CHECK_INCLUDE_FILE( "unistd.h" LIBWBXML_TOOLS_UNISTD_H )
IF( ${LIBWBXML_TOOLS_UNISTD_H} )
	SET( CMAKE_REQUIRED_INCLUDES ${LIBWBXML_TOOLS_UNISTD_H} )
	CHECK_FUNCTION_EXISTS( getopt LIBWBXML_POSIX_GETOPT )
ELSE( ${LIBWBXML_TOOLS_UNISTD_H} )
	SET( LIBWBXML_POSIX_GETOPT OFF )
ENDIF( ${LIBWBXML_TOOLS_UNISTD_H} )
IF( LIBWBXML_POSIX_GETOPT )
	OPTION( FOUND_POSIX_GETOPT "POSIX getopt" ON )
ELSE( LIBWBXML_POSIX_GETOPT )
	OPTION( FOUND_POSIX_GETOPT "POSIX getopt" OFF )
ENDIF( LIBWBXML_POSIX_GETOPT )

# look for the commands required for testing

FIND_PROGRAM( PERL_PROGRAM "perl" )
FIND_PROGRAM( DIFF_PROGRAM "diff" )

IF( PERL_PROGRAM )
	SET( ENABLE_PERL ON )
ELSE( PERL_PROGRAM )
	SET( ENABLE_PERL OFF )
ENDIF( PERL_PROGRAM )

IF( DIFF_PROGRAM )
	SET( ENABLE_DIFF ON )
ELSE( DIFF_PROGRAM )
	SET( ENABLE_DIFF OFF )
ENDIF( DIFF_PROGRAM )

OPTION( BUILD_SHARED_LIBS "Build wbxml as shared library" ON )
OPTION( BUILD_STATIC_LIBS "Build wbxml as static library" OFF )
OPTION( WBXML_LIB_VERBOSE "verbose mode" OFF )
OPTION( WBXML_ENCODER_USE_STRTBL "enable string tables" ON )
OPTION( WBXML_SUPPORT_WML "enable WML support" ON )
OPTION( WBXML_SUPPORT_WTA "enable WTA support" ON )
OPTION( WBXML_SUPPORT_SI "enable SI support" ON )
OPTION( WBXML_SUPPORT_SL "enable SL support" ON )
OPTION( WBXML_SUPPORT_CO "enable CO support" ON )
OPTION( WBXML_SUPPORT_PROV "enable PROV support" ON )
OPTION( WBXML_SUPPORT_EMN "enable EMN support" ON )
OPTION( WBXML_SUPPORT_DRMREL "enable DRMREL support" ON )
OPTION( WBXML_SUPPORT_OTA_SETTINGS "enable OTA_SETTINGS support" ON )
OPTION( WBXML_SUPPORT_SYNCML "enable SYNCML support" ON )
OPTION( WBXML_SUPPORT_WV "enable WV support" ON )
OPTION( WBXML_SUPPORT_AIRSYNC "enable AIRSYNC support" ON )
OPTION( WBXML_SUPPORT_CONML "enable Nokia ConML support" ON )
OPTION( WBXML_INSTALL_FULL_HEADERS "install internal headers" OFF )

SET( PACKAGE "libwbxml" )
SET( PACKAGE_BUGREPORT " " )
SET( PACKAGE_NAME "libwbxml" )
SET( PACKAGE_TARNAME "${PACKAGE_NAME}" )
SET( PACKAGE_STRING "${PACKAGE_NAME} ${LIBWBXML_VERSION}" )
SET( PACKAGE_VERSION "${LIBWBXML_VERSION}" )
SET( VERSION "${LIBWBXML_VERSION}" )

CONFIGURE_FILE( "src/wbxml_config.h.cmake" "${CMAKE_CURRENT_BINARY_DIR}/wbxml_config.h")
CONFIGURE_FILE( "src/wbxml_config_internals.h.cmake" "${CMAKE_CURRENT_BINARY_DIR}/wbxml_config_internals.h")
CONFIGURE_FILE( "libwbxml2.pc.cmake" "${CMAKE_CURRENT_BINARY_DIR}/libwbxml2.pc" @ONLY)

# add uninstall target
CONFIGURE_FILE(	"${CMAKE_SOURCE_DIR}/cmake/modules/cmake_uninstall.cmake.in" "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake" IMMEDIATE @ONLY)

ADD_CUSTOM_TARGET(uninstall "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

ADD_SUBDIRECTORY( src )
ADD_SUBDIRECTORY( tools )
ADD_SUBDIRECTORY( cmake )

MARK_AS_ADVANCED( CLEAR BUILD_DOCUMENTATION )
#IF ( BUILD_DOCUMENTATION )
#	IF ( DOXYGEN_DOT_EXECUTABLE )
#		SET( HAVE_DOT "YES" )
#	ENDIF ( DOXYGEN_DOT_EXECUTABLE )
#
#	# configure tools documentation
#	CONFIGURE_FILE( "tools/Doxyfile.in" "${CMAKE_CURRENT_BINARY_DIR}/tools/Doxyfile" @ONLY)
#	ADD_CUSTOM_TARGET( DoxygenDocTools ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/tools/Doxyfile )
#
#	# configure library documentation
#	CONFIGURE_FILE( "libsyncml/Doxyfile.in" "${CMAKE_CURRENT_BINARY_DIR}/libsyncml/Doxyfile" @ONLY)
#	ADD_CUSTOM_TARGET( DoxygenDocLibrary ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/libsyncml/Doxyfile )
#
#	# configure general doxygen target
#	CONFIGURE_FILE( "misc/doxygen.css" "${CMAKE_CURRENT_BINARY_DIR}/misc/doxygen.css" @ONLY)
#	# WARNING: Do not use DEPENDS of ADD_CUSTOM_TARGET here
#	ADD_CUSTOM_TARGET( DoxygenDoc )
#	ADD_DEPENDENCIES( DoxygenDoc DoxygenDocLibrary DoxygenDocTools )
#ENDIF ( BUILD_DOCUMENTATION )
OPTION( ENABLE_INSTALL_DOC "install documentation" ON )
IF( ENABLE_INSTALL_DOC )
	ADD_DOCUMENTATION( TEXT FILE ${CMAKE_SOURCE_DIR}/BUGS )
	ADD_DOCUMENTATION( TEXT FILE ${CMAKE_SOURCE_DIR}/ChangeLog )
	ADD_DOCUMENTATION( TEXT FILE ${CMAKE_SOURCE_DIR}/COPYING )
	ADD_DOCUMENTATION( TEXT FILE ${CMAKE_SOURCE_DIR}/GNU-LGPL )
	ADD_DOCUMENTATION( TEXT FILE ${CMAKE_SOURCE_DIR}/INSTALL )
	ADD_DOCUMENTATION( TEXT FILE ${CMAKE_SOURCE_DIR}/README )
	ADD_DOCUMENTATION( TEXT FILE ${CMAKE_SOURCE_DIR}/References )
	ADD_DOCUMENTATION( TEXT FILE ${CMAKE_SOURCE_DIR}/THANKS )
	ADD_DOCUMENTATION( TEXT FILE ${CMAKE_SOURCE_DIR}/TODO )
ENDIF( ENABLE_INSTALL_DOC )

# todo: add requires in pc file
INSTALL( FILES "${CMAKE_CURRENT_BINARY_DIR}/libwbxml2.pc" DESTINATION "${LIBDATA_INSTALL_DIR}/pkgconfig/" )
# status output
INCLUDE( ShowStatus )
MESSAGE( STATUS "==================================================" )
SHOW_STATUS( WBXML_LIB_VERBOSE "verbose mode\t\t\t" )
SHOW_STATUS( FOUND_POSIX_GETOPT "POSIX getopt\t\t\t" )
SHOW_STATUS( ENABLE_UNIT_TEST "unit tests\t\t\t" )
SHOW_STATUS( ENABLE_PERL "perl binary (test generated XML)" )
SHOW_STATUS( ENABLE_DIFF "diff binary (test generated XML)" )
SHOW_STATUS( WBXML_ENCODER_USE_STRTBL "enable string tables\t\t" )
SHOW_STATUS( WBXML_SUPPORT_WML "enable WML support\t\t" )
SHOW_STATUS( WBXML_SUPPORT_WTA "enable WTA support\t\t" )
SHOW_STATUS( WBXML_SUPPORT_SI "enable SI support\t\t" )
SHOW_STATUS( WBXML_SUPPORT_SL "enable SL support\t\t" )
SHOW_STATUS( WBXML_SUPPORT_CO "enable CO support\t\t" )
SHOW_STATUS( WBXML_SUPPORT_PROV "enable PROV support\t\t" )
SHOW_STATUS( WBXML_SUPPORT_EMN "enable EMN support\t\t" )
SHOW_STATUS( WBXML_SUPPORT_DRMREL "enable DRMREL support\t" )
SHOW_STATUS( WBXML_SUPPORT_OTA_SETTINGS "enable OTA_SETTINGS support\t" )
SHOW_STATUS( WBXML_SUPPORT_SYNCML "enable SYNCML support\t" )
SHOW_STATUS( WBXML_SUPPORT_WV "enable WV support\t\t" )
SHOW_STATUS( WBXML_SUPPORT_AIRSYNC "enable AIRSYNC support\t" )
SHOW_STATUS( WBXML_SUPPORT_CONML "enable Nokia ConML support\t" )
SHOW_STATUS( BUILD_DOCUMENTATION "build dynamic documentation\t" )
SHOW_STATUS( WBXML_SUPPORT_ICONV "enable iconv support\t\t" )
SHOW_STATUS( ENABLE_INSTALL_DOC "install documentation\t" )
SHOW_STATUS( WBXML_INSTALL_FULL_HEADERS "install internal headers\t" )

# fatal error detection
IF ( FATAL_ERROR_EXPAT )
	MESSAGE( STATUS "==================================================" )
	MESSAGE( STATUS "FATAL ERROR(S) DETECTED ... DETAILS FOLLOW:" )
	MESSAGE( STATUS "==================================================" )
	IF ( FATAL_ERROR_EXPAT )
		MESSAGE( STATUS "${FATAL_ERROR_EXPAT}" )
	ENDIF ( FATAL_ERROR_EXPAT )
	MESSAGE( STATUS "==================================================" )
ENDIF ( FATAL_ERROR_EXPAT )

### CPack ########################################

IF( RELEASE_CANDIDATE )
	SET( LIBWBXML_VERSION "${LIBWBXML_VERSION}-RC${RELEASE_CANDIDATE}" )
ENDIF( RELEASE_CANDIDATE )

=== cmake/CMakeLists.txt ===

# Standard header and include paths were already defined.

include(CMakePackageConfigHelpers)

configure_package_config_file(
    libwbxml2-config.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/libwbxml2-config.cmake
    INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/libwbxml2
    PATH_VARS
        LIBWBXML_LIBRARIES_DIR
        LIBWBXML_INCLUDE_DIR
)

# Please note: All libwbxml releases of the 0.11 series are downward compatible until v0.11.0.
write_basic_package_version_file("${CMAKE_CURRENT_BINARY_DIR}/libwbxml2-config-version.cmake"
  VERSION "${LIBWBXML_VERSION}"
  COMPATIBILITY SameMinorVersion )

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libwbxml2-config.cmake
              ${CMAKE_CURRENT_BINARY_DIR}/libwbxml2-config-version.cmake
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/libwbxml2 )

=== src/CMakeLists.txt ===

if(COMMAND cmake_policy AND POLICY CMP0042)
       cmake_policy (SET CMP0042 NEW)
endif(COMMAND cmake_policy AND POLICY CMP0042)

LINK_DIRECTORIES( ${EXPAT_LIBRARY_DIRS} )

INCLUDE_DIRECTORIES( ${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR} ${EXPAT_INCLUDE_DIRS} )

SET( libwbxml_LIB_SRCS
	wbxml_base64.c
	wbxml_buffers.c
	wbxml_charset.c
	wbxml_conv.c
	wbxml_elt.c
	wbxml_encoder.c
	wbxml_errors.c
	wbxml_lists.c
	wbxml_log.c
	wbxml_mem.c
	wbxml_parser.c
	wbxml_tables.c
	wbxml_tree.c
	wbxml_tree_clb_wbxml.c
	wbxml_tree_clb_xml.c
)

IF(BUILD_SHARED_LIBS)
	ADD_LIBRARY( wbxml2 SHARED ${libwbxml_LIB_SRCS} )

	SET_TARGET_PROPERTIES( wbxml2 PROPERTIES SOVERSION ${LIBWBXML_LIBVERSION_SOVERSION} )
	SET_TARGET_PROPERTIES( wbxml2 PROPERTIES VERSION ${LIBWBXML_LIBVERSION_VERSION} )
	TARGET_LINK_LIBRARIES( wbxml2 PRIVATE ${EXPAT_LIBRARIES} )

	INSTALL( TARGETS wbxml2
   	   RUNTIME DESTINATION ${LIBWBXML_BIN_DIR}
   	   LIBRARY DESTINATION ${LIBWBXML_LIBRARIES_DIR}
   	   ARCHIVE DESTINATION ${LIBWBXML_LIBRARIES_DIR}
	)
ENDIF()

IF(BUILD_STATIC_LIBS)
	ADD_LIBRARY( wbxml2_static STATIC ${libwbxml_LIB_SRCS} )

	SET_TARGET_PROPERTIES( wbxml2_static PROPERTIES SOVERSION ${LIBWBXML_LIBVERSION_SOVERSION} )
	SET_TARGET_PROPERTIES( wbxml2_static PROPERTIES VERSION ${LIBWBXML_LIBVERSION_VERSION} )
	TARGET_LINK_LIBRARIES( wbxml2_static PRIVATE ${EXPAT_LIBRARIES} )
	SET_TARGET_PROPERTIES( wbxml2_static PROPERTIES OUTPUT_NAME wbxml2 )

	INSTALL( TARGETS wbxml2_static
   	   RUNTIME DESTINATION ${LIBWBXML_BIN_DIR}
   	   LIBRARY DESTINATION ${LIBWBXML_LIBRARIES_DIR}
   	   ARCHIVE DESTINATION ${LIBWBXML_LIBRARIES_DIR}
	)
ENDIF()


INSTALL( FILES
	wbxml.h
	${CMAKE_CURRENT_BINARY_DIR}/../wbxml_config.h
	wbxml_conv.h
	wbxml_defines.h
	wbxml_errors.h
	DESTINATION ${LIBWBXML_INCLUDE_DIR}/wbxml
)

IF(WBXML_INSTALL_FULL_HEADERS)
    INSTALL( FILES
        wbxml_base64.h
        wbxml_buffers.h
        wbxml_charset.h
        wbxml_elt.h
        wbxml_encoder.h
        wbxml_handlers.h
        wbxml_lists.h
        wbxml_log.h
        wbxml_mem.h
        wbxml_parser.h
        wbxml_tables.h
        wbxml_tree.h
        wbxml_tree_clb_wbxml.h
        wbxml_tree_clb_xml.h
        DESTINATION ${LIBWBXML_INCLUDE_DIR}/wbxml
    )
ENDIF()

=== tools/CMakeLists.txt ===
LINK_DIRECTORIES( ${EXPAT_LIBRARY_DIRS} )

INCLUDE_DIRECTORIES( ${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR} ${EXPAT_INCLUDE_DIRS} )

if(COMMAND cmake_policy)
	cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

CONFIGURE_FILE( "config.h.cmake" "${CMAKE_CURRENT_BINARY_DIR}/config.h")

IF( LIBWBXML_POSIX_GETOPT )
	SET( ATTGETOPT "" )
ELSE( LIBWBXML_POSIX_GETOPT )
	SET( ATTGETOPT "attgetopt.c" )
ENDIF( LIBWBXML_POSIX_GETOPT )

ADD_EXECUTABLE( wbxml2xml wbxml2xml_tool.c ${ATTGETOPT} )
IF(BUILD_SHARED_LIBS)
	TARGET_LINK_LIBRARIES( wbxml2xml wbxml2 )
ELSE(BUILD_SHARED_LIBS)
	TARGET_LINK_LIBRARIES( wbxml2xml wbxml2_static )
ENDIF()
	INSTALL( TARGETS wbxml2xml DESTINATION ${LIBWBXML_BIN_DIR} )

ADD_EXECUTABLE( xml2wbxml xml2wbxml_tool.c ${ATTGETOPT} )
IF(BUILD_SHARED_LIBS)
	TARGET_LINK_LIBRARIES( xml2wbxml wbxml2 )
ELSE(BUILD_SHARED_LIBS)
	TARGET_LINK_LIBRARIES( xml2wbxml wbxml2_static )
ENDIF()
	INSTALL( TARGETS xml2wbxml DESTINATION ${LIBWBXML_BIN_DIR} )

=== test/api/CMakeLists.txt ===

if(COMMAND cmake_policy)
    cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

ENABLE_TESTING()
FIND_PACKAGE( PkgConfig REQUIRED)
PKG_CHECK_MODULES( CHECK REQUIRED check )

INCLUDE_DIRECTORIES( ${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR} ${CHECK_INCLUDE_DIRS} )

## Test private API

FOREACH( SRC_FILE lists buffers base64 charset conv encoder_internals errors parser_internals )

    ADD_EXECUTABLE(test_wbxml_${SRC_FILE} test_wbxml_${SRC_FILE}.c api_test.c)

IF(BUILD_SHARED_LIBS)    
    TARGET_LINK_LIBRARIES(test_wbxml_${SRC_FILE} wbxml2)
ELSE(BUILD_SHARED_LIBS)
    TARGET_LINK_LIBRARIES(test_wbxml_${SRC_FILE} wbxml2_static)
ENDIF()

    IF( PKG_CONFIG_FOUND )
    TARGET_LINK_LIBRARIES(test_wbxml_${SRC_FILE} ${CHECK_LDFLAGS})
    ELSE ( PKG_CONFIG_FOUND )
    TARGET_LINK_LIBRARIES(test_wbxml_${SRC_FILE} ${CHECK_LIBRARIES})
    ENDIF ( PKG_CONFIG_FOUND )

    ADD_TEST(api_private_wbxml_${SRC_FILE} ${CMAKE_CURRENT_BINARY_DIR}/test_wbxml_${SRC_FILE})

ENDFOREACH( SRC_FILE lists  )

=== test/fuzz/CMakeLists.txt ===

ENABLE_TESTING()

# Please note, the provided test files originally caused system level crashs.
SET( FUZZ_FILES
    SIGABRT.PC.fffff7db0a10.STACK.0.CODE.-6.ADDR.0.INSTR.cmn_w0_0x1_lsl_12.2024-03-07.035819.705486.fuzz
    SIGSEGV.PC.aaaaaaae3998.STACK.0.CODE.1.ADDR.8.INSTR.ldrb_w8_x8_8.2024-03-07.035825.707512.fuzz
    SIGSEGV.PC.aaaaaaae39ac.STACK.0.CODE.1.ADDR.8.INSTR.ldrb_w20_x21_8.2024-03-11.003303.27182.fuzz
   )
SET( WBXML2XML "${CMAKE_CURRENT_BINARY_DIR}/../../tools/wbxml2xml" )

FOREACH( FUZZ_FILE IN LISTS FUZZ_FILES )
    SET( TEST_NAME "Fuzz_file_${FUZZ_FILE}" )
    ADD_TEST( NAME ${TEST_NAME} COMMAND ${WBXML2XML} "${CMAKE_CURRENT_SOURCE_DIR}/${FUZZ_FILE}" )
    # Please note, a system level crash like SIGABRT or SIGSEGV would cause this test to fail.
    # The regular expression ensures that the library returned a proper error.
    SET_PROPERTY( TEST ${TEST_NAME} PROPERTY WILL_FAIL TRUE)
    SET_PROPERTY( TEST ${TEST_NAME} PROPERTY FAIL_REGULAR_EXPRESSION "wbxml2xml failed: ")
ENDFOREACH()

=== debian/control ===
Source: wbxml2
Priority: optional
Section: libs
Maintainer: Mike Gabriel <sunweaver@debian.org>
Uploaders: Debian UBports Team <team+ubports@tracker.debian.org>,
Build-Depends:
 check,
 cmake,
 debhelper-compat (= 13),
 libexpat1-dev,
 libpopt-dev,
 pkgconf,
 zlib1g-dev,
Rules-Requires-Root: no
Standards-Version: 4.7.0
Homepage: https://github.com/libwbxml/libwbxml
Vcs-Git: https://salsa.debian.org/debian/wbxml2.git
Vcs-Browser: https://salsa.debian.org/debian/wbxml2

Package: libwbxml2-1
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Provides: libwbxml2-abi-1-00-08
Multi-Arch: same
Description: WBXML parsing and encoding library
 The WBXML Library (aka libwbxml) contains a library and its associated
 tools to Parse, Encode and Handle WBXML documents.  The WBXML format
 is a binary representation of XML, defined by the Wap Forum, and used
 to reduce bandwidth in mobile communications.
 .
 This package contains the dynamic library needed by applications
 using libwbxml2.

Package: libwbxml2-dev
Section: libdevel
Architecture: any
Depends:
 libexpat1-dev,
 libpopt-dev,
 libwbxml2-1 (= ${binary:Version}),
 zlib1g-dev,
 ${misc:Depends},
Description: WBXML library development file
 The WBXML Library (aka libwbxml) contains a library and its associated
 tools to Parse, Encode and Handle WBXML documents.  The WBXML format
 is a binary representation of XML, defined by the Wap Forum, and used
 to reduce bandwidth in mobile communications.
 .
 Install this package if you wish to develop your own programs using
 WBXML.

Package: libwbxml2-private-dev
Section: libdevel
Architecture: any
Depends:
 libwbxml2-dev (= ${binary:Version}),
 ${misc:Depends},
Description: WBXML library private development files
 The WBXML Library (aka libwbxml) contains a library and its associated
 tools to Parse, Encode and Handle WBXML documents.  The WBXML format
 is a binary representation of XML, defined by the Wap Forum, and used
 to reduce bandwidth in mobile communications.
 .
 Install this package if you need to build packages requiring the
 porivate symbols from the WBXML library.

Package: libwbxml2-utils
Section: text
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Binary XML utilities
 The WBXML Library (aka libwbxml) contains a library and its associated
 tools to Parse, Encode and Handle WBXML documents.  The WBXML format
 is a binary representation of XML, defined by the Wap Forum, and used
 to reduce bandwidth in mobile communications.
 .
 This package contains wbxml2xml and xml2wbxml utils to convert xml
 files to wbxml and back.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DPKG_GENSYMBOLS_CHECK_LEVEL=4

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --repack --destdir=..

=== debian/watch ===
version=4
opts="dversionmangle=s/\+dfsg\d*$//, repacksuffix=+dfsg" \
https://github.com/libwbxml/libwbxml/tags /libwbxml/libwbxml/archive/refs/tags/libwbxml-([\d\.]+).tar.gz
